; ================================================================== 
;	FullHD81  *  2015  *  Gal, Zsolt
; ================================================================== 
;
	.org $4009		; 16393
;
; ================================================================== 
;	ZX81 SYSTEM VARIABLES
; ================================================================== 
;
;	   the next 51 bytes will be overwritten during startup
;	------------------------------------------------------------
INIT
dblINI	.equ (2*INIT)& $7FFF
	;
	; --------------------------------- VERSN,E_PPC,D_FILE,DF_CC
	;
	ld b,0			; MSB of the counter
	ld de,$4000		; dest. addr.
	jr INITcont		;
	;
	; ----------------------------------------------------------
	;
	.dw Variables		; VARS
	.dw $0000		; DEST
	.dw eof_Prg 		; E_LINE
	.dw eof_Prg+4		; CH_ADD
	.dw $0000		; X_PTR
	.dw $0000		; STKBOT
	.dw $0000		; STKEND
	.db 0			; BREG
	.dw $0000		; MEM
	;
	; ------------------------------- UNUSED1,DF_SZ,S_TOP,LAST_K
INITcont
	ld hl,reloc		; src. addr.
	call expand		;
	;
	; ----------------------------------------------------------
	;
	.db 0			; DEBOUN
MARGIN	.db 0			; MARGIN
	.dw Begin		; NXTLIN  -  autostart
	.dw 0			; OLDPPC
	.db 0			; FLAGX
	.dw $0000		; STRLEN
	.dw $0000		; T_ADDR
	.dw $0000		; SEED

	.dw $0000		; FRAMES

	.dw $0000		; COORDS
	.db $0000		; PR_CC
	.dw $0000		; S_POSN
CDFLAG	.db $00			; CDFLAG  -  starts in ZX80 (FAST) mode
	;
	; ==========================================================
	;
cursor_u
	ld b,c			; step=1
cursor_ud
	ld hl,Voffs1		; pointer to the
	ld a,(hl)		; top margin's offset
	add a,b			; change its value (+/-1)

	cp 16			; check the lower limit
	jr c,keyboard		; if under, then no change

	cp 33			; check the upper limit
	jr nc,keyboard		; if over, then no change

	ld (hl),a		; save the new value
	ld a,48			; and set
	sub (hl)		; the offset for
	ld (Voffs2),a		; the bottom margin
	
	jr keyboard		; back to the main loop
	;
	; ----------------------------------------------------------
cursor_r
	ld b,c			; step=1
cursor_lr
	ld hl,Hoffs		; pointer to the
	ld a,(hl)		; horizontal offset
	add a,b			; (+/-1)
	add a,b			; (+/-1)
	cp 17			; if over/under the limit
	jr nc,keyboard		; then no change

	ld (hl),a		; save the new value
	jr keyboard		; back to the main loop
;
; ================================================ the video driver section
;
temp_sp	.equ $+1
dfe_exit
	ld sp,$8000		; restore stack pointer

	ld a,(MARGIN)		; set bottom margin
	;
Voffs2	.equ $+1
	;
	sub 24			; the offset
	ld (MARGIN),a		;

	call $292		; return to application program
	call $220		; extra register push and vsync
	call HR_setup		; reload the hr vector
	jp $02a4		; return to application program
	;
	; ==========================================================
HR_drv
	ld (temp_sp),sp		; save the stack pointer
	ld sp,HR_stack		; set SP for hires routines
	;
	ld c,$F8		; C = lower byte of the next
	;			  stack pointer
	; ----------------------------------------------------------
	;
Hoffs	.equ $+1
	;
	jr $+10			; T75 - T12 (+/-4TS) delay:
	;
	jr dly_47		; T71 - T24 delay
	jr dly_48		; T72 - T24 delay
	jr dly_49		; T73 - T24 delay
	jr dly_50		; T74 - T24 delay
	jr dly_51		; T75 - T24 delay
	jr dly_52		; T76 - T24 delay
	jr dly_53		; T77 - T24 delay
	jr dly_54		; T78 - T24 delay
	jr dly_55		; T79 - T24 delay
	;
	; ----------------------------------------------------------
dly_52
	nop			; T4 delay
dly_48
	dec hl			; T6 delay
	jr dly_30		; T12 delay
dly_53
	nop			; T4 delay
dly_49
	ld a,(hl)		; T7 delay
	jr dly_30		; T12 delay
dly_54
	nop			; T4 delay
dly_50
	jr dly_38		; T12 delay
dly_55
	nop			; T4 delay
dly_51
	nop			; T4 delay
dly_47
	ld a,i			; T9 delay
dly_38
	nop			; T4 delay
	nop			; T4 delay
dly_30
	ld a,(hl)		; T7 delay
	and (hl)		; T7 delay
	jr $+2			; T12 delay
	xor a			; clear CY (T4 delay)
	;
	; ----------------------------------------------------------
	;
	ret			; jp df_exec 
	;
	; ----------------------------------------------------------
	;
	.db 0
;
; =========================================================================
;
HR_setup
	ld ix,HR_drv		; load the hr vector
	;
        ex af,af'		; set top margin
	;
Voffs1	.equ $+1
	;
	add a,24		; the offset
	ex af,af'		;
	ret			;
;
; =========================================================================
;
ChgStack
	ld l,c			; set stack pointer to the end of
	ld sp,hl		; the 6th hires line in the chunk
	ld a,208		; addr. of the 6th hires line
dfe_cont
	jp dfe_ldR		; continue d-file execution
;
; ======================================================== the dummy D-FILE
;
df_exec	.equ $+$8000

	pop hl			; get line address
	ld a,h			;
	ld i,a			; set MSB
	ld a,l			;
	;
dfe_ldR	.equ $+$8000

	ld r,a			; set LSB
;
;	==========================================================
;	   the next 40 bytes will be overwritten during startup
;	==========================================================
ddf_data
	.db 128			; the 1st byte of the line buffer
;
;	----------------------------------------------------------
expand
	ld c,60			; overwrites the first 60 bytes
	ldir			;
	;
	; --------------------------------------------------------
	; this part expands the hires file and inserts the
	; portions of HR-stack
	; --------------------------------------------------------
	;
	ld de,$40F7+$2802 	; end of the expanded hires data +2
	ld hl,reloc-1		; end of the unexpanded hires data +2
	ld c,242		; the last chunk contains 6 lines
				; + the latest return address (dfe_exit)
	ld a,39			; copy 39 chunks
expand1
	lddr			; copy 6 lines of the h-file
	;
	push hl			; save the "from" pointer
	;
	ld hl,Line000+1		; the first common part
	ld c,13			; of the stack (+2 dummy bytes)
	lddr			; copy
	;
	inc hl			;
	dec (hl)		; modify the chunk address upper byte
	dec hl			;
	;
	ld c,3			; copy the rest
	lddr			;
	;
	pop hl			; restore the "from" pointer
	;
	ld c,240		; a chunk contains 6 lines (6x40 bytes)
	dec a			; last?
	jr nz,expand1		; if no, repeat
	;
	jr invert		; clean the ddf_data
;
;	============================================================
;
	ret nc			;
;
; ============================================ the picture inverter routine
;
invert
	ld hl,ddf_data		; addr. of the line buffer
	ld b,40			; it contains 40 bytes
	ld a,(hl)		; the 1st element
	xor $80			; toggle the inverse bit
inv_fill
	ld (hl),a		; and fill the
	inc hl			; whole buffer
	djnz inv_fill		;
	ret
;
; ========================================================== HI-RES section
;
HR_stack
	.dw df_exec,Line000+$2700			;
	.dw NextLine,NextLine,NextLine,NextLine		;
	.dw ChgStack					;
;
;	==================================================== 
;		320x240 pixel hires data (9600 bytes)
;	==================================================== 
Line000
	.incbin "FullHD81demo.bin"	; 
;
; ------------------------------------------------------------------
;
	.dw dfe_exit	;  the last return address in the HR_stack
;
; =========================================================== the MAIN LOOP
;
reloc
	; the next 60 bytes will be copied to the beginning of the memory 
	; -----------------------------------------------------------------

	.org $4000		; 16384
keyboard
	ld hl,LAST_K		; the status of the keyboard
	ld a,(hl)		;
key_sta
	cp (hl)			; is it changed?
	jr z,key_sta		; no, read again

	inc a			; if non of the keys are pressed,
	jr nz,keyboard		; then read again

	ld c,(hl)		; read the lower
	inc hl
	ld b,(hl)		; and the upper byte
	call $07bd		; ROM: DECODE
	ld a,(hl)		; the decoded character

	ld bc,$FF01		; B= -1; C= +1

	sub $70			; cursor up (SHIFT+7) ?
	jr z,cursor_u		;

	dec a			; cursor down (SHIFT+6) ?
	jr z,cursor_ud		;

	dec a			; cursor left (SHIFT+5) ?
	jr z,cursor_lr		;

	dec a			; cursor right (SHIFT+8) ?
	jr z,cursor_r		;

	dec a			; graphics (SHIFT+9) ?
	jr skip1		;
;
;	-------------------------------------------- S_TOP_hi,LAST_K
;
	.db $00
LAST_K	.dw $0000
;
;	---------------- DEBOUN,MARGIN,NXTLIN,OLDPPC,FLAGX,STRLEN_lo
;
	call $0207		; switch the SLOW mode
	call HR_setup		; set top margin and the hr vector
	jr keyboard		; main loop
;
;	-------------------------------------- STRLEN_hi,T_ADDR,SEED 
skip1
	call z,invert		; inverts the picture
	jr keyboard		; back to the main loop
;
;	------------------------------------------------------------
;
	.dw $0000		; FRAMES
;
; ---------------------------------------------- COORDS,PR_CC,S_POSN
;
NextLine
	add a,40		; the next line in the 256B chunk
	jp dfe_cont		; continue d-file execution
;
; ------------------------------------------------------------------
;
	.db $40			; CDFLAG  -  it's a ZX81
;
; ======================================================== ZX BASIC section
;
	.org reloc+60		;
Begin
	.db $00,$01		; Basic Line 1
	.dw Variables-RAND_USR	; Length of Basic Line 1
RAND_USR
	.db $F9,$D4,$26,$76	; RAND USR A N/L
;
;	==================================================== Variables area
Variables
	.db $66,$8F		;
	.db dblINI/256		;
	.db dblINI&255		;
	.db $00,$00		; A=INIT
	;
	.db $80			; end of variables/program
eof_Prg
.end

