unit FullHD81main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnLoad: TButton;
    btnSave: TButton;
    Image: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblDept: TLabel;
    lblHeight: TLabel;
    lblWidth: TLabel;
    OpenDlg: TOpenDialog;
    grpSaveAs: TRadioGroup;
    ProgBar: TProgressBar;
    SaveDlg: TSaveDialog;
    procedure WrSoundfile(var f:file);
    procedure WrScanline(var f:textfile;LineNum:integer);
    procedure WrStackline(var f:textfile;LineNum:integer);
    procedure btnSaveClick(Sender: TObject);
    function chgBitOrder(AByte: byte): byte;
    procedure chkPicture;
    procedure btnLoadClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    ThePicture: array[0..239,0..39] of byte;
    InvPicture: array[0..239,0..39] of byte;
    BlackPixels: integer;
  end;

var
  Form1: TForm1;

const
  ZX_before : array[0..254] of byte = (
    $06,$00,$11,$00,$40,$18,$11,$CE,$66,$00,$00,$D5,$66,$D9,$66,$00,
    $00,$00,$00,$00,$00,$00,$00,$00,$21,$8A,$66,$CD,$C5,$40,$00,$00,
    $C6,$66,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
    $00,$00,$00,$41,$21,$B3,$40,$7E,$80,$FE,$10,$38,$BA,$FE,$21,$30,
    $B6,$77,$3E,$30,$96,$32,$68,$40,$18,$AD,$41,$21,$82,$40,$7E,$80,
    $80,$FE,$11,$30,$A2,$77,$18,$9F,$31,$00,$80,$3A,$28,$40,$D6,$18,
    $32,$28,$40,$CD,$92,$02,$CD,$20,$02,$CD,$AD,$40,$C3,$A4,$02,$ED,
    $73,$62,$40,$31,$FA,$40,$0E,$F8,$18,$08,$18,$1D,$18,$0F,$18,$11,
    $18,$13,$18,$14,$18,$06,$18,$08,$18,$0A,$18,$0B,$00,$2B,$18,$0D,
    $00,$7E,$18,$09,$00,$18,$04,$00,$00,$ED,$57,$00,$00,$7E,$A6,$18,
    $00,$AF,$C9,$00,$DD,$21,$78,$40,$08,$C6,$18,$08,$C9,$69,$F9,$3E,
    $D0,$C3,$C2,$C0,$E1,$7C,$ED,$47,$7D,$ED,$4F,$80,$0E,$3C,$ED,$B0,
    $11,$F9,$68,$21,$89,$66,$0E,$F2,$3E,$27,$ED,$B8,$E5,$21,$09,$41,
    $0E,$0D,$ED,$B8,$23,$35,$2B,$0E,$03,$ED,$B8,$E1,$0E,$F0,$3D,$20,
    $E9,$18,$01,$D0,$21,$C4,$40,$06,$28,$7E,$EE,$80,$77,$23,$10,$FC,
    $C9,$BD,$C0,$08,$68,$36,$40,$36,$40,$36,$40,$36,$40,$B6,$40);

  ZX_after : array[0..76] of byte = (
    $61,$40,$21,$25,$40,$7E,$BE,$28,$FD,$3C,$20,$F6,$4E,$23,$46,$CD,
    $BD,$07,$7E,$01,$01,$FF,$D6,$70,$28,$24,$3D,$28,$22,$3D,$28,$36,
    $3D,$28,$32,$3D,$18,$0B,$00,$00,$00,$CD,$07,$02,$CD,$AD,$40,$18,
    $D1,$CC,$ED,$40,$18,$CC,$00,$00,$C6,$28,$C3,$BA,$40,$40,$00,$01,
    $04,$00,$F9,$D4,$26,$76,$66,$8F,$00,$12,$00,$00,$80);

  Header : array[0..43] of byte = (
    $52,$49,$46,$46,$00,$00,$00,$00,$57,$41,$56,$45,$66,$6D,$74,$20,
    $10,$00,$00,$00,$01,$00,$01,$00,$44,$AC,$00,$00,$44,$AC,$00,$00,
    $01,$00,$08,$00,$64,$61,$74,$61,$00,$00,$00,$00);

  TheBit : array[0..7] of byte = ($80,$40,$20,$10,$08,$04,$02,$01);

implementation

{$R *.lfm}

{ TForm1 }

function TForm1.chgBitOrder(AByte: byte):byte;
var
  newByte: byte;
begin
  NewByte:=0;
  if (AByte and $80)=0 then begin
    NewByte:=NewByte or $01;
    inc(BlackPixels);
  end;
  if (AByte and $40)=0 then begin
    NewByte:=NewByte or $02;
    inc(BlackPixels);
  end;
  if (AByte and $20)=0 then begin
    NewByte:=NewByte or $04;
    inc(BlackPixels);
  end;
  if (AByte and $10)=0 then begin
    NewByte:=NewByte or $08;
    inc(BlackPixels);
  end;
  if (AByte and $08)=0 then begin
    NewByte:=NewByte or $10;
    inc(BlackPixels);
  end;
  if (AByte and $04)=0 then begin
    NewByte:=NewByte or $20;
    inc(BlackPixels);
  end;
  if (AByte and $02)=0 then begin
    NewByte:=NewByte or $40;
    inc(BlackPixels);
  end;
  if (AByte and $01)=0 then begin
    NewByte:=NewByte or $80;
    inc(BlackPixels);
  end;
  Result:=NewByte;
end;

procedure TForm1.chkPicture;
var
  PictOK: boolean;
  x,y: integer;
  ABytePtr: PByte;
begin
  with Image.Picture.Bitmap do begin
    lblWidth.Caption:=IntToStr(Width);
    if Width<>320 then lblWidth.Font.Color:=clRed
      else lblWidth.Font.Color:=clDefault;
    lblHeight.Caption:=IntToStr(Height);
    if Height<>240 then lblHeight.Font.Color:=clRed
      else lblHeight.Font.Color:=clDefault;
    lblDept.Caption:=IntToStr(RawImage.Description.BitsPerPixel);
    if RawImage.Description.BitsPerPixel<>1 then begin
      lblDept.Font.Color:=clRed;
      PictOK:=false;
    end
    else begin
      lblDept.Font.Color:=clDefault;
      PictOK:=true;
    end;
    PictOK:=PictOK and (Height=240) and (Width=320);
    grpSaveAs.Enabled:=PictOK;
    btnSave.Enabled:=PictOK;

    ABytePtr:=RawImage.Data;
    if PictOK then begin
      BlackPixels:=0;
      for y:=0 to 239 do for x:=0 to 39 do begin
        ThePicture[y,x]:=chgBitOrder(ABytePtr^);
        InvPicture[y,x]:=$FF xor ThePicture[y,x];
        inc(ABytePtr);
      end;
    if BlackPixels<(4800*8) then ZX_before[187]:=$80
    else  ZX_before[187]:=$00;
    end;
  end;
end;

procedure TForm1.WrSoundfile(var f:file);
const
  AWave: array[0..5] of byte = ($F8,$F8,$F8,$08,$08,$08);
  ASilence: array[0..4] of byte = ($80,$80,$80,$80,$80);

  procedure wrSilence;
  var j,error : integer;
  begin //0.1sec (441*5=2205 sample
    for j:=1 to 441 do BlockWrite(f,ASilence[0],SizeOf(ASilence),error);
  end;

  procedure wrSlowByte(AByte : byte);
  var j,k,error : integer;
  begin
    for j:=0 to 7 do begin
      for k:=1 to 6 do BlockWrite(f,ASilence[0],SizeOf(ASilence),error);
      k:=4;
      if (AByte and TheBit[j])>0 then k:=9;
      while (k>0) do begin

        BlockWrite(f,AWave[0],SizeOf(AWave),error);
        dec(k);
      end;
    end;
  end;

var
  i: integer;
  ABytePtr: PByte;
begin

  btnSave.Visible:=false;
  for i:=1 to 30 do wrSilence;  // 3sec silence

  // the filename: HD81
  wrSlowByte($2D);    {'H'}
  wrSlowByte($29);    {'D'}
  wrSlowByte($24);    {'8'}
  wrSlowByte($9D);    {inv.'1'}

  ProgBar.Position:=0;
  ProgBar.Visible:=true;

  for i:=0 to 254 do wrSlowByte(ZX_before[i]);
  ProgBar.Position:=i;

  if BlackPixels<(4800*8) then ABytePtr:=@ThePicture[0,0]
  else ABytePtr:=@InvPicture[0,0];

  for i:=1 to 9600 do begin
    wrSlowByte(ABytePtr^);
    ProgBar.Position:=i+254;
    inc(ABytePtr);
  end;

  for i:=0 to 76 do wrSlowByte(ZX_after[i]);
  ProgBar.Position:=ProgBar.Max;
  wrSilence;
  ProgBar.Visible:=false;
  btnSave.Visible:=true;
end;

procedure TForm1.WrScanline(var f:textfile;LineNum:integer);
var
  AStr: string;
  x: integer;
begin
  AStr:=IntToStr(LineNum);
  while length(AStr)<3 do AStr:='0'+AStr;
  AStr:='line'+AStr;
  Writeln(f,AStr);

  AStr:=#9+'.db ';
  for x:=0 to 19 do begin
    AStr:=AStr+'$'+IntToHex(ThePicture[LineNum,x],2);
    if x<>19 then AStr:=AStr+',';
  end;
  Writeln(f,AStr);

  AStr:=#9+'.db ';
  for x:=20 to 39 do begin
    AStr:=AStr+'$'+IntToHex(ThePicture[LineNum,x],2);
    if x<>39 then AStr:=AStr+',';
  end;
  Writeln(f,AStr);
end;

procedure TForm1.WrStackline(var f:textfile;LineNum:integer);
var
  AStr: string;
  x: integer;
begin
  if (LineNum mod 6)=0 then begin
    if (LineNum =0) then Writeln(f,'HR_stack')
    else Writeln(f,#9,';');
    Writeln(f,#9,'.dw df_exec');

    AStr:=IntToStr(LineNum);
    while length(AStr)<3 do AStr:='0'+AStr;
    AStr:=#9+'.dw line'+AStr;
    Writeln(f,AStr);
    for x:=1 to 4 do Writeln(f,#9,'.dw NextLine');

    Writeln(f,#9,'.dw ChgStack');
    if (LineNum <>0) then Writeln(f,#9,'.dw 0');
  end;
  WrScanline(f,LineNum);
end;

procedure TForm1.btnSaveClick(Sender: TObject);
var
  bf: file of byte;
  wf: file of integer;
  tf: textfile;
  ARow, error,
  AFSize : integer;
begin
  case grpSaveAs.ItemIndex of
  0: SaveDlg.DefaultExt:='.p';
  1: SaveDlg.DefaultExt:='.wav';
  2: SaveDlg.DefaultExt:='.bin';  //viewer (*.wav)
  3: SaveDlg.DefaultExt:='.def';
  4: SaveDlg.DefaultExt:='.inc';
  end;
  SaveDlg.FilterIndex:=grpSaveAs.ItemIndex+1;
  SaveDlg.FileName:='FullHD81demo';
  if SaveDlg.Execute then begin

    grpSaveAs.ItemIndex:=SaveDlg.FilterIndex-1;
    case SaveDlg.FilterIndex of
    1: begin
      AssignFile(bf,SaveDlg.FileName);
      Rewrite(bf);
      BlockWrite(bf,ZX_before[0],SizeOf(ZX_before),error);

      if BlackPixels<(4800*8)
      then BlockWrite(bf,ThePicture[0,0],SizeOf(ThePicture),error)
      else BlockWrite(bf,InvPicture[0,0],SizeOf(InvPicture),error);

      BlockWrite(bf,ZX_after[0],SizeOf(ZX_after),error);
      CloseFile(bf);
    end;
    2: begin
      AssignFile(bf,SaveDlg.FileName);
      Rewrite(bf);
      BlockWrite(bf,Header[0],SizeOf(Header),error);
      WrSoundfile(bf);
      AFSize:=FileSize(bf)-8;
      CloseFile(bf);

      AssignFile(wf,SaveDlg.FileName);
      Reset(wf);
      Seek(wf,1);
      write(wf,AFSize);

      AFSize:=AFSize-36;
      Seek(wf,10);
      write(wf,AFSize);

      AFSize:=22050;
      Seek(wf,6);
      write(wf,AFSize);
      write(wf,AFSize);
      CloseFile(wf);
    end;
    3: begin
      AssignFile(bf,SaveDlg.FileName);
      Rewrite(bf);
      BlockWrite(bf,ThePicture[0,0],SizeOf(ThePicture),error);
      CloseFile(bf);
    end;
    4: begin
      AssignFile(tf,SaveDlg.FileName);
      Rewrite(tf);
      for ARow:=0 to 239 do WrScanline(tf,ARow);
      CloseFile(tf);
    end;
    5: begin
      AssignFile(tf,SaveDlg.FileName);
      Rewrite(tf);
      for ARow:=0 to 239 do WrStackline(tf,ARow);
      Writeln(tf,#9,';');
      Writeln(tf,#9,'.dw dfe_exit');
      CloseFile(tf);
    end;

    end;
  end;
end;

procedure TForm1.btnLoadClick(Sender: TObject);
begin
  if OpenDlg.Execute then begin
    if (FileExistsUTF8(OpenDlg.FileName)) then begin

      Image.Picture.LoadFromFile(OpenDlg.FileName);
      chkPicture;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  chkPicture;

end;

end.

